﻿namespace EyeSoft.Nhibernate.Test.Data
{
	using System.Data.SqlClient;

	using EyeSoft.Data.Common;
	using EyeSoft.Nhibernate.Test.Mapping;

	using NHibernate.Cfg;
	using NHibernate.Dialect;
	using NHibernate.Mapping.ByCode;

	public static class NhibernateHelper
	{
		private static readonly SqlConnectionStringBuilder connectionBuilder =
			new SqlConnectionStringBuilder
			{
				DataSource = @".\SQLExpress",
				InitialCatalog = "Nh.Collection.Test",
				IntegratedSecurity = true
			};

		public static Configuration Configuration()
		{
			var mapper = new ModelMapper();

			var mappingType = typeof(CustomerMapping);
			var exportedTypes = mappingType.Assembly.GetExportedTypes();

			mapper.AddMappings(exportedTypes);

			var mapping = mapper.CompileMappingForAllExplicitlyAddedEntities();

			var xml = mapping.AsString();

			var configuration = new Configuration();

			configuration.DataBaseIntegration(db =>
				{
					db.Dialect<MsSql2012Dialect>();
					db.ConnectionString = connectionBuilder.ConnectionString;
					db.AutoCommentSql = true;
					db.IsolationLevel = System.Data.IsolationLevel.ReadCommitted;
					db.KeywordsAutoImport = Hbm2DDLKeyWords.AutoQuote;
					db.PrepareCommands = true;
				});

			configuration.AddMapping(mapping);
			return configuration;
		}

		public static IDatabaseProvider DatabaseProvider()
		{
			var databaseProvider = connectionBuilder.GetDatabaseProvider();

			return databaseProvider;
		}
	}
}