﻿namespace EyeSoft.Nhibernate.Test.Mapping
{
	using EyeSoft.Nhibernate.Test.Domain;

	using NHibernate.Mapping.ByCode;
	using NHibernate.Mapping.ByCode.Conformist;

	public class CustomerMapping : ClassMapping<Customer>
	{
		public CustomerMapping()
		{
			Id(x => x.Id, m => m.Generator(Generators.Assigned));

			Property(x => x.Name);

			ManyToOne(x => x.Fiscal, m => m.Cascade(Cascade.Merge));

			Bag(
				x => x.Addresses,
				m =>
					{
						m.Cascade(Cascade.Merge | Cascade.DeleteOrphans);
						m.Inverse(true);
					},
				r => r.OneToMany());
		}
	}
}